/* pathbar.c generated by valac 0.40.3, the Vala compiler
 * generated from pathbar.vala, do not modify */

/*
  This file is part of Dconf Editor

  Dconf Editor is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dconf Editor is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dconf Editor.  If not, see <https://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>


#define TYPE_PATH_BAR (path_bar_get_type ())
#define PATH_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PATH_BAR, PathBar))
#define PATH_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PATH_BAR, PathBarClass))
#define IS_PATH_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PATH_BAR))
#define IS_PATH_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PATH_BAR))
#define PATH_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PATH_BAR, PathBarClass))

typedef struct _PathBar PathBar;
typedef struct _PathBarClass PathBarClass;
typedef struct _PathBarPrivate PathBarPrivate;

#define TYPE_PATH_BAR_ITEM (path_bar_item_get_type ())
#define PATH_BAR_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PATH_BAR_ITEM, PathBarItem))
#define PATH_BAR_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PATH_BAR_ITEM, PathBarItemClass))
#define IS_PATH_BAR_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PATH_BAR_ITEM))
#define IS_PATH_BAR_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PATH_BAR_ITEM))
#define PATH_BAR_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PATH_BAR_ITEM, PathBarItemClass))

typedef struct _PathBarItem PathBarItem;
typedef struct _PathBarItemClass PathBarItemClass;
enum  {
	PATH_BAR_0_PROPERTY,
	PATH_BAR_COMPLETE_PATH_PROPERTY,
	PATH_BAR_NUM_PROPERTIES
};
static GParamSpec* path_bar_properties[PATH_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_VIEW_TYPE (view_type_get_type ())
typedef struct _Block23Data Block23Data;
typedef struct _Block24Data Block24Data;

#define PATH_BAR_ITEM_TYPE_CURSOR_TYPE (path_bar_item_cursor_type_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block25Data Block25Data;
typedef struct _PathBarItemPrivate PathBarItemPrivate;
enum  {
	PATH_BAR_ITEM_0_PROPERTY,
	PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY,
	PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY,
	PATH_BAR_ITEM_TEXT_STRING_PROPERTY,
	PATH_BAR_ITEM_NUM_PROPERTIES
};
static GParamSpec* path_bar_item_properties[PATH_BAR_ITEM_NUM_PROPERTIES];

struct _PathBar {
	GtkBox parent_instance;
	PathBarPrivate * priv;
};

struct _PathBarClass {
	GtkBoxClass parent_class;
};

struct _PathBarPrivate {
	PathBarItem* root_button;
	gchar* _complete_path;
};

typedef enum  {
	VIEW_TYPE_OBJECT,
	VIEW_TYPE_FOLDER,
	VIEW_TYPE_SEARCH
} ViewType;

struct _Block23Data {
	int _ref_count_;
	PathBar* self;
	gchar** split;
	gint split_length1;
	gint _split_size_;
	gboolean destroy_all;
	gboolean maintain_all;
	ViewType type;
};

struct _Block24Data {
	int _ref_count_;
	PathBar* self;
	gchar* action_target;
	gchar* non_ghost_path;
	gboolean is_search;
};

typedef enum  {
	PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT,
	PATH_BAR_ITEM_CURSOR_TYPE_POINTER,
	PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT
} PathBarItemCursorType;

struct _Block25Data {
	int _ref_count_;
	PathBar* self;
	gboolean is_search;
};

struct _PathBarItem {
	GtkButton parent_instance;
	PathBarItemPrivate * priv;
};

struct _PathBarItemClass {
	GtkButtonClass parent_class;
};

struct _PathBarItemPrivate {
	gchar* _alternative_action;
	gchar* _default_action;
	gchar* _text_string;
	GtkLabel* text_label;
	PathBarItemCursorType cursor_type;
	gboolean hover;
};


static gpointer path_bar_parent_class = NULL;
static gpointer path_bar_item_parent_class = NULL;

GType path_bar_get_type (void) G_GNUC_CONST;
GType path_bar_item_get_type (void) G_GNUC_CONST;
#define PATH_BAR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PATH_BAR, PathBarPrivate))
GType view_type_get_type (void) G_GNUC_CONST;
void path_bar_set_path (PathBar* self,
                        ViewType type,
                        const gchar* path);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
static void path_bar_update_cursors_for_search (PathBar* self,
                                         const gchar* current_path,
                                         gboolean is_search);
static void path_bar_activate_item (PathBar* self,
                             PathBarItem* item,
                             gboolean state);
static void path_bar_set_complete_path (PathBar* self,
                                 const gchar* value);
static void __lambda22_ (Block23Data* _data23_,
                  GtkWidget* child);
const gchar* path_bar_get_complete_path (PathBar* self);
const gchar* path_bar_item_get_text_string (PathBarItem* self);
static gchar** _vala_array_dup4 (gchar** self,
                          int length);
static void ___lambda22__gtk_callback (GtkWidget* widget,
                                gpointer self);
static void path_bar_add_path_bar_item (PathBar* self,
                                 const gchar* label,
                                 const gchar* complete_path,
                                 gboolean is_folder,
                                 gboolean block);
static void path_bar_add_slash_label (PathBar* self);
gchar* path_bar_get_selected_child (PathBar* self,
                                    const gchar* current_path);
void path_bar_update_ghosts (PathBar* self,
                             const gchar* non_ghost_path,
                             gboolean is_search);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
static void __lambda23_ (Block24Data* _data24_,
                  GtkWidget* child);
GType path_bar_item_cursor_type_get_type (void) G_GNUC_CONST;
void path_bar_item_set_cursor_type (PathBarItem* self,
                                    PathBarItemCursorType cursor_type);
const gchar* path_bar_item_get_default_action (PathBarItem* self);
const gchar* path_bar_item_get_alternative_action (PathBarItem* self);
static void ___lambda23__gtk_callback (GtkWidget* widget,
                                gpointer self);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
static void __lambda21_ (Block25Data* _data25_,
                  GtkWidget* child);
static void ___lambda21__gtk_callback (GtkWidget* widget,
                                gpointer self);
PathBarItem* path_bar_item_new (const gchar* label,
                                const gchar* _default_action,
                                const gchar* _alternative_action);
PathBarItem* path_bar_item_construct (GType object_type,
                                      const gchar* label,
                                      const gchar* _default_action,
                                      const gchar* _alternative_action);
PathBar* path_bar_new (void);
PathBar* path_bar_construct (GType object_type);
static GObject * path_bar_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties);
static void path_bar_finalize (GObject * obj);
static void _vala_path_bar_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_path_bar_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);
#define PATH_BAR_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PATH_BAR_ITEM, PathBarItemPrivate))
static void path_bar_item_set_new_cursor_type (PathBarItem* self,
                                        PathBarItemCursorType new_cursor_type);
static void path_bar_item_update_cursor (PathBarItem* self);
static void _path_bar_item_update_cursor_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
static void path_bar_item_set_alternative_action (PathBarItem* self,
                                           const gchar* value);
static void path_bar_item_set_default_action (PathBarItem* self,
                                       const gchar* value);
static void path_bar_item_set_text_string (PathBarItem* self,
                                    const gchar* value);
static GObject * path_bar_item_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static gboolean _path_bar_item___lambda19_ (PathBarItem* self);
static gboolean __path_bar_item___lambda19__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                    GdkEventCrossing* event,
                                                                    gpointer self);
static gboolean _path_bar_item___lambda20_ (PathBarItem* self);
static gboolean __path_bar_item___lambda20__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                    GdkEventCrossing* event,
                                                                    gpointer self);
static void path_bar_item_finalize (GObject * obj);
static void _vala_path_bar_item_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_path_bar_item_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
	g_atomic_int_inc (&_data23_->_ref_count_);
	return _data23_;
}


static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
		PathBar* self;
		self = _data23_->self;
		_data23_->split = (_vala_array_free (_data23_->split, _data23_->split_length1, (GDestroyNotify) g_free), NULL);
		_g_object_unref0 (self);
		g_slice_free (Block23Data, _data23_);
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static gchar**
_vala_array_dup4 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


static void
__lambda22_ (Block23Data* _data23_,
             GtkWidget* child)
{
	PathBar* self;
	PathBarItem* item = NULL;
	PathBarItem* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp13_ = FALSE;
	PathBarItem* _tmp14_;
	PathBarItem* _tmp15_;
	self = _data23_->self;
	g_return_if_fail (child != NULL);
	if (G_TYPE_CHECK_INSTANCE_TYPE (child, gtk_label_get_type ())) {
		gboolean _tmp0_;
		_tmp0_ = _data23_->destroy_all;
		if (_tmp0_) {
			gtk_widget_destroy (child);
		} else {
			const gchar* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
			_tmp1_ = self->priv->_complete_path;
			_tmp2_ = g_strconcat (_tmp1_, "/", NULL);
			_tmp3_ = _tmp2_;
			path_bar_set_complete_path (self, _tmp3_);
			_g_free0 (_tmp3_);
		}
		return;
	}
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, TYPE_PATH_BAR_ITEM, PathBarItem));
	item = _tmp4_;
	_tmp5_ = _data23_->maintain_all;
	if (_tmp5_) {
		const gchar* _tmp6_;
		PathBarItem* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		PathBarItem* _tmp12_;
		_tmp6_ = self->priv->_complete_path;
		_tmp7_ = item;
		_tmp8_ = path_bar_item_get_text_string (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_strconcat (_tmp6_, _tmp9_, NULL);
		_tmp11_ = _tmp10_;
		path_bar_set_complete_path (self, _tmp11_);
		_g_free0 (_tmp11_);
		_tmp12_ = item;
		path_bar_activate_item (self, _tmp12_, FALSE);
		_g_object_unref0 (item);
		return;
	}
	_tmp14_ = item;
	_tmp15_ = self->priv->root_button;
	if (_tmp14_ == _tmp15_) {
		_tmp13_ = TRUE;
	} else {
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_;
		_tmp17_ = _data23_->destroy_all;
		if (!_tmp17_) {
			PathBarItem* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar** _tmp21_;
			gint _tmp21__length1;
			const gchar* _tmp22_;
			_tmp18_ = item;
			_tmp19_ = path_bar_item_get_text_string (_tmp18_);
			_tmp20_ = _tmp19_;
			_tmp21_ = _data23_->split;
			_tmp21__length1 = _data23_->split_length1;
			_tmp22_ = _tmp21_[0];
			_tmp16_ = g_strcmp0 (_tmp20_, _tmp22_) == 0;
		} else {
			_tmp16_ = FALSE;
		}
		_tmp13_ = _tmp16_;
	}
	if (_tmp13_) {
		const gchar* _tmp23_;
		gchar** _tmp24_;
		gint _tmp24__length1;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar** _tmp28_;
		gint _tmp28__length1;
		gchar** _tmp29_;
		gint _tmp29__length1;
		gchar** _tmp30_;
		gint _tmp30__length1;
		gboolean _tmp31_ = FALSE;
		gchar** _tmp32_;
		gint _tmp32__length1;
		_tmp23_ = self->priv->_complete_path;
		_tmp24_ = _data23_->split;
		_tmp24__length1 = _data23_->split_length1;
		_tmp25_ = _tmp24_[0];
		_tmp26_ = g_strconcat (_tmp23_, _tmp25_, NULL);
		_tmp27_ = _tmp26_;
		path_bar_set_complete_path (self, _tmp27_);
		_g_free0 (_tmp27_);
		_tmp28_ = _data23_->split;
		_tmp28__length1 = _data23_->split_length1;
		_tmp29_ = _data23_->split;
		_tmp29__length1 = _data23_->split_length1;
		_tmp30_ = ((_tmp28_ + 1) != NULL) ? _vala_array_dup4 (_tmp28_ + 1, _tmp29__length1 - 1) : ((gpointer) (_tmp28_ + 1));
		_tmp30__length1 = _tmp29__length1 - 1;
		_data23_->split = (_vala_array_free (_data23_->split, _data23_->split_length1, (GDestroyNotify) g_free), NULL);
		_data23_->split = _tmp30_;
		_data23_->split_length1 = _tmp30__length1;
		_data23_->_split_size_ = _data23_->split_length1;
		_tmp32_ = _data23_->split;
		_tmp32__length1 = _data23_->split_length1;
		if (_tmp32__length1 == 0) {
			_tmp31_ = TRUE;
		} else {
			gboolean _tmp33_ = FALSE;
			gchar** _tmp34_;
			gint _tmp34__length1;
			_tmp34_ = _data23_->split;
			_tmp34__length1 = _data23_->split_length1;
			if (_tmp34__length1 == 1) {
				_tmp33_ = _data23_->type == VIEW_TYPE_FOLDER;
			} else {
				_tmp33_ = FALSE;
			}
			_tmp31_ = _tmp33_;
		}
		if (_tmp31_) {
			PathBarItem* _tmp35_;
			_tmp35_ = item;
			path_bar_activate_item (self, _tmp35_, TRUE);
			_data23_->maintain_all = TRUE;
		} else {
			PathBarItem* _tmp36_;
			_tmp36_ = item;
			path_bar_activate_item (self, _tmp36_, FALSE);
		}
		_g_object_unref0 (item);
		return;
	}
	gtk_widget_destroy (child);
	_data23_->destroy_all = TRUE;
	_g_object_unref0 (item);
}


static void
___lambda22__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
	__lambda22_ (self, widget);
}


void
path_bar_set_path (PathBar* self,
                   ViewType type,
                   const gchar* path)
{
	Block23Data* _data23_;
	PathBarItem* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar* last = NULL;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_data23_ = g_slice_new0 (Block23Data);
	_data23_->_ref_count_ = 1;
	_data23_->self = g_object_ref (self);
	_data23_->type = type;
	if (_data23_->type == VIEW_TYPE_SEARCH) {
		path_bar_update_cursors_for_search (self, path, TRUE);
		block23_data_unref (_data23_);
		_data23_ = NULL;
		return;
	}
	path_bar_update_cursors_for_search (self, path, FALSE);
	_tmp0_ = self->priv->root_button;
	path_bar_activate_item (self, _tmp0_, g_strcmp0 (path, "/") == 0);
	path_bar_set_complete_path (self, "");
	_tmp2_ = _tmp1_ = g_strsplit (path, "/", 0);
	_data23_->split = _tmp2_;
	_data23_->split_length1 = _vala_array_length (_tmp1_);
	_data23_->_split_size_ = _data23_->split_length1;
	_tmp3_ = _data23_->split;
	_tmp3__length1 = _data23_->split_length1;
	_tmp4_ = _data23_->split;
	_tmp4__length1 = _data23_->split_length1;
	_tmp5_ = _tmp3_[_tmp4__length1 - 1];
	_tmp6_ = g_strdup (_tmp5_);
	last = _tmp6_;
	_data23_->destroy_all = FALSE;
	_data23_->maintain_all = FALSE;
	gtk_container_foreach ((GtkContainer*) self, ___lambda22__gtk_callback, _data23_);
	_tmp7_ = _data23_->split;
	_tmp7__length1 = _data23_->split_length1;
	if (_tmp7__length1 > 0) {
		gchar** _tmp8_;
		gint _tmp8__length1;
		_tmp8_ = _data23_->split;
		_tmp8__length1 = _data23_->split_length1;
		if (_tmp8__length1 > 1) {
			guint index = 0U;
			gchar** _tmp9_;
			gint _tmp9__length1;
			gchar** _tmp10_;
			gint _tmp10__length1;
			index = (guint) 0;
			_tmp9_ = _data23_->split;
			_tmp9__length1 = _data23_->split_length1;
			_tmp10_ = _data23_->split;
			_tmp10__length1 = _data23_->split_length1;
			{
				gchar** item_collection = NULL;
				gint item_collection_length1 = 0;
				gint _item_collection_size_ = 0;
				gint item_it = 0;
				item_collection = _tmp9_ + 0;
				item_collection_length1 = (_tmp10__length1 - 1) - 0;
				for (item_it = 0; item_it < ((_tmp10__length1 - 1) - 0); item_it = item_it + 1) {
					gchar* _tmp11_;
					gchar* item = NULL;
					_tmp11_ = g_strdup (item_collection[item_it]);
					item = _tmp11_;
					{
						const gchar* _tmp12_;
						const gchar* _tmp13_;
						gchar* _tmp14_;
						gchar* _tmp15_;
						gchar* _tmp16_;
						gchar* _tmp17_;
						gboolean _tmp18_ = FALSE;
						const gchar* _tmp21_;
						const gchar* _tmp22_;
						guint _tmp23_;
						_tmp12_ = self->priv->_complete_path;
						_tmp13_ = item;
						_tmp14_ = g_strconcat (_tmp13_, "/", NULL);
						_tmp15_ = _tmp14_;
						_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
						_tmp17_ = _tmp16_;
						path_bar_set_complete_path (self, _tmp17_);
						_g_free0 (_tmp17_);
						_g_free0 (_tmp15_);
						if (_data23_->type == VIEW_TYPE_FOLDER) {
							guint _tmp19_;
							gchar** _tmp20_;
							gint _tmp20__length1;
							_tmp19_ = index;
							_tmp20_ = _data23_->split;
							_tmp20__length1 = _data23_->split_length1;
							_tmp18_ = _tmp19_ == ((guint) (_tmp20__length1 - 2));
						} else {
							_tmp18_ = FALSE;
						}
						_tmp21_ = item;
						_tmp22_ = self->priv->_complete_path;
						path_bar_add_path_bar_item (self, _tmp21_, _tmp22_, TRUE, _tmp18_);
						path_bar_add_slash_label (self);
						_tmp23_ = index;
						index = _tmp23_ + 1;
						_g_free0 (item);
					}
				}
			}
		}
		if (_data23_->type == VIEW_TYPE_OBJECT) {
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			_tmp24_ = self->priv->_complete_path;
			_tmp25_ = last;
			_tmp26_ = g_strconcat (_tmp24_, _tmp25_, NULL);
			_tmp27_ = _tmp26_;
			path_bar_set_complete_path (self, _tmp27_);
			_g_free0 (_tmp27_);
			_tmp28_ = last;
			_tmp29_ = self->priv->_complete_path;
			path_bar_add_path_bar_item (self, _tmp28_, _tmp29_, FALSE, TRUE);
		}
	}
	gtk_widget_show_all ((GtkWidget*) self);
	_g_free0 (last);
	block23_data_unref (_data23_);
	_data23_ = NULL;
}


static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		glong _tmp2_;
		_tmp2_ = string_length;
		start = _tmp2_ + start;
	}
	if (end < ((glong) 0)) {
		glong _tmp3_;
		_tmp3_ = string_length;
		end = _tmp3_ + end;
	}
	if (start >= ((glong) 0)) {
		glong _tmp5_;
		_tmp5_ = string_length;
		_tmp4_ = start <= _tmp5_;
	} else {
		_tmp4_ = FALSE;
	}
	g_return_val_if_fail (_tmp4_, NULL);
	if (end >= ((glong) 0)) {
		glong _tmp7_;
		_tmp7_ = string_length;
		_tmp6_ = end <= _tmp7_;
	} else {
		_tmp6_ = FALSE;
	}
	g_return_val_if_fail (_tmp6_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp8_;
	return result;
}


gchar*
path_bar_get_selected_child (PathBar* self,
                             const gchar* current_path)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gint index_of_last_slash = 0;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_ = NULL;
	gint _tmp8_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (current_path != NULL, NULL);
	_tmp1_ = self->priv->_complete_path;
	if (!g_str_has_prefix (_tmp1_, current_path)) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = self->priv->_complete_path;
		_tmp0_ = g_strcmp0 (_tmp2_, current_path) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup ("");
		result = _tmp3_;
		return result;
	}
	_tmp4_ = self->priv->_complete_path;
	_tmp5_ = strlen (current_path);
	_tmp6_ = _tmp5_;
	index_of_last_slash = string_index_of (_tmp4_, "/", _tmp6_);
	_tmp8_ = index_of_last_slash;
	if (_tmp8_ == -1) {
		const gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp9_ = self->priv->_complete_path;
		_tmp10_ = g_strdup (_tmp9_);
		_g_free0 (_tmp7_);
		_tmp7_ = _tmp10_;
	} else {
		const gchar* _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
		_tmp11_ = self->priv->_complete_path;
		_tmp12_ = index_of_last_slash;
		_tmp13_ = string_slice (_tmp11_, (glong) 0, (glong) (_tmp12_ + 1));
		_g_free0 (_tmp7_);
		_tmp7_ = _tmp13_;
	}
	result = _tmp7_;
	return result;
}


static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
	g_atomic_int_inc (&_data24_->_ref_count_);
	return _data24_;
}


static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
		PathBar* self;
		self = _data24_->self;
		_g_free0 (_data24_->action_target);
		_g_free0 (_data24_->non_ghost_path);
		_g_object_unref0 (self);
		g_slice_free (Block24Data, _data24_);
	}
}


static gpointer
_g_variant_ref0 (gpointer self)
{
	return self ? g_variant_ref (self) : NULL;
}


static void
__lambda23_ (Block24Data* _data24_,
             GtkWidget* child)
{
	PathBar* self;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	self = _data24_->self;
	g_return_if_fail (child != NULL);
	_tmp0_ = gtk_widget_get_style_context (child);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	context = _tmp1_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (child, TYPE_PATH_BAR_ITEM)) {
		PathBarItem* item = NULL;
		PathBarItem* _tmp2_;
		GVariant* variant = NULL;
		PathBarItem* _tmp3_;
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		const gchar* _tmp8_;
		GtkStyleContext* _tmp13_;
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, TYPE_PATH_BAR_ITEM, PathBarItem));
		item = _tmp2_;
		_tmp3_ = item;
		_tmp4_ = gtk_actionable_get_action_target_value ((GtkActionable*) _tmp3_);
		_tmp5_ = _g_variant_ref0 (_tmp4_);
		variant = _tmp5_;
		_tmp6_ = variant;
		if (_tmp6_ == NULL) {
			g_assert_not_reached ();
		}
		_tmp7_ = variant;
		_tmp8_ = g_variant_get_type_string ((GVariant*) _tmp7_);
		if (g_strcmp0 (_tmp8_, "s") == 0) {
			GVariant* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			_tmp9_ = variant;
			_tmp10_ = g_variant_get_string ((GVariant*) _tmp9_, NULL);
			_tmp11_ = g_strdup (_tmp10_);
			_g_free0 (_data24_->action_target);
			_data24_->action_target = _tmp11_;
		} else {
			gchar* unused = NULL;
			GVariant* _tmp12_;
			_tmp12_ = variant;
			g_variant_get ((GVariant*) _tmp12_, "(ss)", &_data24_->action_target, &unused, NULL);
			_g_free0 (unused);
		}
		_tmp13_ = context;
		if (gtk_style_context_has_class (_tmp13_, "active")) {
			GtkStyleContext* _tmp21_;
			if (_data24_->is_search) {
				PathBarItem* _tmp14_;
				PathBarItem* _tmp15_;
				PathBarItem* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				_tmp14_ = item;
				path_bar_item_set_cursor_type (_tmp14_, PATH_BAR_ITEM_CURSOR_TYPE_POINTER);
				_tmp15_ = item;
				_tmp16_ = item;
				_tmp17_ = path_bar_item_get_default_action (_tmp16_);
				_tmp18_ = _tmp17_;
				gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp15_, _tmp18_);
			} else {
				PathBarItem* _tmp19_;
				PathBarItem* _tmp20_;
				_tmp19_ = item;
				path_bar_item_set_cursor_type (_tmp19_, PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT);
				_tmp20_ = item;
				gtk_actionable_set_action_name ((GtkActionable*) _tmp20_, "ui.empty");
			}
			_tmp21_ = context;
			gtk_style_context_remove_class (_tmp21_, "inexistent");
		} else {
			if (g_str_has_prefix (_data24_->non_ghost_path, _data24_->action_target)) {
				PathBarItem* _tmp22_;
				PathBarItem* _tmp23_;
				PathBarItem* _tmp24_;
				const gchar* _tmp25_;
				const gchar* _tmp26_;
				GtkStyleContext* _tmp27_;
				_tmp22_ = item;
				path_bar_item_set_cursor_type (_tmp22_, PATH_BAR_ITEM_CURSOR_TYPE_POINTER);
				_tmp23_ = item;
				_tmp24_ = item;
				_tmp25_ = path_bar_item_get_default_action (_tmp24_);
				_tmp26_ = _tmp25_;
				gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp23_, _tmp26_);
				_tmp27_ = context;
				gtk_style_context_remove_class (_tmp27_, "inexistent");
			} else {
				PathBarItem* _tmp28_;
				PathBarItem* _tmp29_;
				PathBarItem* _tmp30_;
				const gchar* _tmp31_;
				const gchar* _tmp32_;
				GtkStyleContext* _tmp33_;
				_tmp28_ = item;
				path_bar_item_set_cursor_type (_tmp28_, PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT);
				_tmp29_ = item;
				_tmp30_ = item;
				_tmp31_ = path_bar_item_get_alternative_action (_tmp30_);
				_tmp32_ = _tmp31_;
				gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp29_, _tmp32_);
				_tmp33_ = context;
				gtk_style_context_add_class (_tmp33_, "inexistent");
			}
		}
		_g_variant_unref0 (variant);
		_g_object_unref0 (item);
	} else {
		if (g_str_has_prefix (_data24_->non_ghost_path, _data24_->action_target)) {
			GtkStyleContext* _tmp34_;
			_tmp34_ = context;
			gtk_style_context_remove_class (_tmp34_, "inexistent");
		} else {
			GtkStyleContext* _tmp35_;
			_tmp35_ = context;
			gtk_style_context_add_class (_tmp35_, "inexistent");
		}
	}
	_g_object_unref0 (context);
}


static void
___lambda23__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
	__lambda23_ (self, widget);
}


void
path_bar_update_ghosts (PathBar* self,
                        const gchar* non_ghost_path,
                        gboolean is_search)
{
	Block24Data* _data24_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (non_ghost_path != NULL);
	_data24_ = g_slice_new0 (Block24Data);
	_data24_->_ref_count_ = 1;
	_data24_->self = g_object_ref (self);
	_tmp0_ = g_strdup (non_ghost_path);
	_g_free0 (_data24_->non_ghost_path);
	_data24_->non_ghost_path = _tmp0_;
	_data24_->is_search = is_search;
	_tmp1_ = g_strdup ("");
	_data24_->action_target = _tmp1_;
	gtk_container_foreach ((GtkContainer*) self, ___lambda23__gtk_callback, _data24_);
	block24_data_unref (_data24_);
	_data24_ = NULL;
}


static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
	g_atomic_int_inc (&_data25_->_ref_count_);
	return _data25_;
}


static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
		PathBar* self;
		self = _data25_->self;
		_g_object_unref0 (self);
		g_slice_free (Block25Data, _data25_);
	}
}


static void
__lambda21_ (Block25Data* _data25_,
             GtkWidget* child)
{
	PathBar* self;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	PathBarItem* item = NULL;
	PathBarItem* _tmp3_;
	self = _data25_->self;
	g_return_if_fail (child != NULL);
	if (!G_TYPE_CHECK_INSTANCE_TYPE (child, TYPE_PATH_BAR_ITEM)) {
		return;
	}
	_tmp0_ = gtk_widget_get_style_context (child);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	context = _tmp1_;
	_tmp2_ = context;
	if (!gtk_style_context_has_class (_tmp2_, "active")) {
		_g_object_unref0 (context);
		return;
	}
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, TYPE_PATH_BAR_ITEM, PathBarItem));
	item = _tmp3_;
	if (_data25_->is_search) {
		PathBarItem* _tmp4_;
		PathBarItem* _tmp5_;
		PathBarItem* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		_tmp4_ = item;
		path_bar_item_set_cursor_type (_tmp4_, PATH_BAR_ITEM_CURSOR_TYPE_POINTER);
		_tmp5_ = item;
		_tmp6_ = item;
		_tmp7_ = path_bar_item_get_default_action (_tmp6_);
		_tmp8_ = _tmp7_;
		gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp5_, _tmp8_);
	} else {
		PathBarItem* _tmp9_;
		PathBarItem* _tmp10_;
		_tmp9_ = item;
		path_bar_item_set_cursor_type (_tmp9_, PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT);
		_tmp10_ = item;
		gtk_actionable_set_action_name ((GtkActionable*) _tmp10_, "ui.empty");
	}
	_g_object_unref0 (item);
	_g_object_unref0 (context);
}


static void
___lambda21__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
	__lambda21_ (self, widget);
}


static void
path_bar_update_cursors_for_search (PathBar* self,
                                    const gchar* current_path,
                                    gboolean is_search)
{
	Block25Data* _data25_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (current_path != NULL);
	_data25_ = g_slice_new0 (Block25Data);
	_data25_->_ref_count_ = 1;
	_data25_->self = g_object_ref (self);
	_data25_->is_search = is_search;
	if (_data25_->is_search) {
		GtkStyleContext* _tmp0_;
		_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
		gtk_style_context_add_class (_tmp0_, "greyed-pathbar");
	} else {
		GtkStyleContext* _tmp1_;
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
		gtk_style_context_remove_class (_tmp1_, "greyed-pathbar");
	}
	gtk_container_foreach ((GtkContainer*) self, ___lambda21__gtk_callback, _data25_);
	block25_data_unref (_data25_);
	_data25_ = NULL;
}


static void
path_bar_add_slash_label (PathBar* self)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GtkLabel*) gtk_label_new ("/");
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
	_g_object_unref0 (_tmp1_);
}


static void
path_bar_add_path_bar_item (PathBar* self,
                            const gchar* label,
                            const gchar* complete_path,
                            gboolean is_folder,
                            gboolean block)
{
	PathBarItem* path_bar_item = NULL;
	PathBarItem* _tmp28_;
	PathBarItem* _tmp29_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (label != NULL);
	g_return_if_fail (complete_path != NULL);
	if (is_folder) {
		GVariant* variant = NULL;
		GVariant* _tmp0_;
		gchar* _variant = NULL;
		GVariant* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		PathBarItem* _tmp13_;
		_tmp0_ = g_variant_new_string (complete_path);
		g_variant_ref_sink (_tmp0_);
		variant = _tmp0_;
		_tmp1_ = variant;
		_tmp2_ = g_variant_print (_tmp1_, FALSE);
		_variant = _tmp2_;
		_tmp3_ = _variant;
		_tmp4_ = g_strconcat ("ui.open-folder(", _tmp3_, NULL);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strconcat (_tmp5_, ")", NULL);
		_tmp7_ = _tmp6_;
		_tmp8_ = _variant;
		_tmp9_ = g_strconcat ("ui.notify-folder-emptied(", _tmp8_, NULL);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strconcat (_tmp10_, ")", NULL);
		_tmp12_ = _tmp11_;
		_tmp13_ = path_bar_item_new (label, _tmp7_, _tmp12_);
		g_object_ref_sink (_tmp13_);
		_g_object_unref0 (path_bar_item);
		path_bar_item = _tmp13_;
		_g_free0 (_tmp12_);
		_g_free0 (_tmp10_);
		_g_free0 (_tmp7_);
		_g_free0 (_tmp5_);
		_g_free0 (_variant);
		_g_variant_unref0 (variant);
	} else {
		GVariant* variant = NULL;
		GVariant* _tmp14_;
		gchar* _variant = NULL;
		GVariant* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		PathBarItem* _tmp27_;
		_tmp14_ = g_variant_new ("(ss)", complete_path, "", NULL);
		g_variant_ref_sink (_tmp14_);
		variant = _tmp14_;
		_tmp15_ = variant;
		_tmp16_ = g_variant_print (_tmp15_, FALSE);
		_variant = _tmp16_;
		_tmp17_ = _variant;
		_tmp18_ = g_strconcat ("ui.open-object(", _tmp17_, NULL);
		_tmp19_ = _tmp18_;
		_tmp20_ = g_strconcat (_tmp19_, ")", NULL);
		_tmp21_ = _tmp20_;
		_tmp22_ = _variant;
		_tmp23_ = g_strconcat ("ui.notify-object-deleted(", _tmp22_, NULL);
		_tmp24_ = _tmp23_;
		_tmp25_ = g_strconcat (_tmp24_, ")", NULL);
		_tmp26_ = _tmp25_;
		_tmp27_ = path_bar_item_new (label, _tmp21_, _tmp26_);
		g_object_ref_sink (_tmp27_);
		_g_object_unref0 (path_bar_item);
		path_bar_item = _tmp27_;
		_g_free0 (_tmp26_);
		_g_free0 (_tmp24_);
		_g_free0 (_tmp21_);
		_g_free0 (_tmp19_);
		_g_free0 (_variant);
		_g_variant_unref0 (variant);
	}
	_tmp28_ = path_bar_item;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp28_);
	_tmp29_ = path_bar_item;
	path_bar_activate_item (self, _tmp29_, block);
	_g_object_unref0 (path_bar_item);
}


static void
path_bar_activate_item (PathBar* self,
                        PathBarItem* item,
                        gboolean state)
{
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) item);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	context = _tmp1_;
	_tmp2_ = context;
	if (state == gtk_style_context_has_class (_tmp2_, "active")) {
		_g_object_unref0 (context);
		return;
	}
	if (state) {
		GtkStyleContext* _tmp3_;
		path_bar_item_set_cursor_type (item, PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT);
		gtk_actionable_set_action_name ((GtkActionable*) item, "ui.empty");
		_tmp3_ = context;
		gtk_style_context_add_class (_tmp3_, "active");
	} else {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		GtkStyleContext* _tmp6_;
		path_bar_item_set_cursor_type (item, PATH_BAR_ITEM_CURSOR_TYPE_POINTER);
		_tmp4_ = path_bar_item_get_default_action (item);
		_tmp5_ = _tmp4_;
		gtk_actionable_set_detailed_action_name ((GtkActionable*) item, _tmp5_);
		_tmp6_ = context;
		gtk_style_context_remove_class (_tmp6_, "active");
	}
	_g_object_unref0 (context);
}


PathBar*
path_bar_construct (GType object_type)
{
	PathBar * self = NULL;
	self = (PathBar*) g_object_new (object_type, NULL);
	return self;
}


PathBar*
path_bar_new (void)
{
	return path_bar_construct (TYPE_PATH_BAR);
}


const gchar*
path_bar_get_complete_path (PathBar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_complete_path;
	result = _tmp0_;
	return result;
}


static void
path_bar_set_complete_path (PathBar* self,
                            const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, path_bar_get_complete_path (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_complete_path);
		self->priv->_complete_path = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, path_bar_properties[PATH_BAR_COMPLETE_PATH_PROPERTY]);
	}
}


static GObject *
path_bar_constructor (GType type,
                      guint n_construct_properties,
                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PathBar * self;
	parent_class = G_OBJECT_CLASS (path_bar_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PATH_BAR, PathBar);
	path_bar_add_slash_label (self);
	return obj;
}


static void
path_bar_class_init (PathBarClass * klass)
{
	gint PathBar_private_offset;
	path_bar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PathBarPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_path_bar_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_path_bar_set_property;
	G_OBJECT_CLASS (klass)->constructor = path_bar_constructor;
	G_OBJECT_CLASS (klass)->finalize = path_bar_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PATH_BAR_COMPLETE_PATH_PROPERTY, path_bar_properties[PATH_BAR_COMPLETE_PATH_PROPERTY] = g_param_spec_string ("complete-path", "complete-path", "complete-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	PathBar_private_offset = g_type_class_get_instance_private_offset (klass);
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/pathbar.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "root_button", FALSE, PathBar_private_offset + G_STRUCT_OFFSET (PathBarPrivate, root_button));
}


static void
path_bar_instance_init (PathBar * self)
{
	gchar* _tmp0_;
	self->priv = PATH_BAR_GET_PRIVATE (self);
	_tmp0_ = g_strdup ("");
	self->priv->_complete_path = _tmp0_;
	g_type_ensure (TYPE_PATH_BAR_ITEM);
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void
path_bar_finalize (GObject * obj)
{
	PathBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PATH_BAR, PathBar);
	_g_object_unref0 (self->priv->root_button);
	_g_free0 (self->priv->_complete_path);
	G_OBJECT_CLASS (path_bar_parent_class)->finalize (obj);
}


GType
path_bar_get_type (void)
{
	static volatile gsize path_bar_type_id__volatile = 0;
	if (g_once_init_enter (&path_bar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PathBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) path_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PathBar), 0, (GInstanceInitFunc) path_bar_instance_init, NULL };
		GType path_bar_type_id;
		path_bar_type_id = g_type_register_static (gtk_box_get_type (), "PathBar", &g_define_type_info, 0);
		g_once_init_leave (&path_bar_type_id__volatile, path_bar_type_id);
	}
	return path_bar_type_id__volatile;
}


static void
_vala_path_bar_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	PathBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PATH_BAR, PathBar);
	switch (property_id) {
		case PATH_BAR_COMPLETE_PATH_PROPERTY:
		g_value_set_string (value, path_bar_get_complete_path (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_path_bar_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	PathBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PATH_BAR, PathBar);
	switch (property_id) {
		case PATH_BAR_COMPLETE_PATH_PROPERTY:
		path_bar_set_complete_path (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


GType
path_bar_item_cursor_type_get_type (void)
{
	static volatile gsize path_bar_item_cursor_type_type_id__volatile = 0;
	if (g_once_init_enter (&path_bar_item_cursor_type_type_id__volatile)) {
		static const GEnumValue values[] = {{PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT, "PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT", "default"}, {PATH_BAR_ITEM_CURSOR_TYPE_POINTER, "PATH_BAR_ITEM_CURSOR_TYPE_POINTER", "pointer"}, {PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT, "PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT", "context"}, {0, NULL, NULL}};
		GType path_bar_item_cursor_type_type_id;
		path_bar_item_cursor_type_type_id = g_enum_register_static ("PathBarItemCursorType", values);
		g_once_init_leave (&path_bar_item_cursor_type_type_id__volatile, path_bar_item_cursor_type_type_id);
	}
	return path_bar_item_cursor_type_type_id__volatile;
}


void
path_bar_item_set_cursor_type (PathBarItem* self,
                               PathBarItemCursorType cursor_type)
{
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->cursor_type = cursor_type;
	_tmp0_ = self->priv->hover;
	if (_tmp0_) {
		path_bar_item_set_new_cursor_type (self, cursor_type);
	}
}


static void
path_bar_item_set_new_cursor_type (PathBarItem* self,
                                   PathBarItemCursorType new_cursor_type)
{
	GdkWindow* gdk_window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp2_;
	GdkDisplay* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GdkWindow* _tmp5_;
	GdkCursor* cursor = NULL;
	GdkWindow* _tmp11_;
	GdkCursor* _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	gdk_window = _tmp1_;
	_tmp2_ = gdk_display_get_default ();
	_tmp3_ = _g_object_ref0 (_tmp2_);
	display = _tmp3_;
	_tmp5_ = gdk_window;
	if (_tmp5_ == NULL) {
		_tmp4_ = TRUE;
	} else {
		GdkDisplay* _tmp6_;
		_tmp6_ = display;
		_tmp4_ = _tmp6_ == NULL;
	}
	if (_tmp4_) {
		_g_object_unref0 (display);
		_g_object_unref0 (gdk_window);
		return;
	}
	cursor = NULL;
	switch (new_cursor_type) {
		case PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT:
		{
			_g_object_unref0 (cursor);
			cursor = NULL;
			break;
		}
		case PATH_BAR_ITEM_CURSOR_TYPE_POINTER:
		{
			GdkDisplay* _tmp7_;
			GdkCursor* _tmp8_;
			_tmp7_ = display;
			_tmp8_ = gdk_cursor_new_from_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gdk_display_get_type (), GdkDisplay), "pointer");
			_g_object_unref0 (cursor);
			cursor = _tmp8_;
			break;
		}
		case PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT:
		{
			GdkDisplay* _tmp9_;
			GdkCursor* _tmp10_;
			_tmp9_ = display;
			_tmp10_ = gdk_cursor_new_from_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gdk_display_get_type (), GdkDisplay), "context-menu");
			_g_object_unref0 (cursor);
			cursor = _tmp10_;
			break;
		}
		default:
		break;
	}
	_tmp11_ = gdk_window;
	_tmp12_ = cursor;
	gdk_window_set_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gdk_window_get_type (), GdkWindow), _tmp12_);
	_g_object_unref0 (cursor);
	_g_object_unref0 (display);
	_g_object_unref0 (gdk_window);
}


static void
path_bar_item_update_cursor (PathBarItem* self)
{
	GtkStyleContext* _tmp0_;
	PathBarItemCursorType _tmp1_;
	GMenu* menu = NULL;
	GMenu* _tmp3_;
	GMenu* _tmp4_;
	GMenu* _tmp5_;
	GtkPopover* popover_test = NULL;
	GMenu* _tmp6_;
	GtkPopover* _tmp7_;
	GtkPopover* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	if (gtk_style_context_has_class (_tmp0_, "inexistent")) {
		return;
	}
	_tmp1_ = self->priv->cursor_type;
	if (_tmp1_ != PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT) {
		PathBarItemCursorType _tmp2_;
		self->priv->cursor_type = PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT;
		_tmp2_ = self->priv->cursor_type;
		path_bar_item_set_new_cursor_type (self, _tmp2_);
		return;
	}
	_tmp3_ = g_menu_new ();
	menu = _tmp3_;
	_tmp4_ = menu;
	g_menu_append (_tmp4_, _ ("Copy current path"), "ui.copy-path");
	_tmp5_ = menu;
	g_menu_freeze (_tmp5_);
	_tmp6_ = menu;
	_tmp7_ = (GtkPopover*) gtk_popover_new_from_model ((GtkWidget*) self, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, g_menu_model_get_type (), GMenuModel));
	g_object_ref_sink (_tmp7_);
	popover_test = _tmp7_;
	_tmp8_ = popover_test;
	gtk_popover_popup (_tmp8_);
	_g_object_unref0 (popover_test);
	_g_object_unref0 (menu);
}


static void
_path_bar_item_update_cursor_gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
	path_bar_item_update_cursor ((PathBarItem*) self);
}


PathBarItem*
path_bar_item_construct (GType object_type,
                         const gchar* label,
                         const gchar* _default_action,
                         const gchar* _alternative_action)
{
	PathBarItem * self = NULL;
	GtkLabel* _tmp0_;
	g_return_val_if_fail (label != NULL, NULL);
	g_return_val_if_fail (_default_action != NULL, NULL);
	g_return_val_if_fail (_alternative_action != NULL, NULL);
	self = (PathBarItem*) g_object_new (object_type, "text-string", label, "default-action", _default_action, "alternative-action", _alternative_action, NULL);
	_tmp0_ = self->priv->text_label;
	gtk_label_set_text (_tmp0_, label);
	gtk_actionable_set_detailed_action_name ((GtkActionable*) self, _default_action);
	return self;
}


PathBarItem*
path_bar_item_new (const gchar* label,
                   const gchar* _default_action,
                   const gchar* _alternative_action)
{
	return path_bar_item_construct (TYPE_PATH_BAR_ITEM, label, _default_action, _alternative_action);
}


const gchar*
path_bar_item_get_alternative_action (PathBarItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_alternative_action;
	result = _tmp0_;
	return result;
}


static void
path_bar_item_set_alternative_action (PathBarItem* self,
                                      const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, path_bar_item_get_alternative_action (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_alternative_action);
		self->priv->_alternative_action = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, path_bar_item_properties[PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY]);
	}
}


const gchar*
path_bar_item_get_default_action (PathBarItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_action;
	result = _tmp0_;
	return result;
}


static void
path_bar_item_set_default_action (PathBarItem* self,
                                  const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, path_bar_item_get_default_action (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_default_action);
		self->priv->_default_action = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, path_bar_item_properties[PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY]);
	}
}


const gchar*
path_bar_item_get_text_string (PathBarItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_text_string;
	result = _tmp0_;
	return result;
}


static void
path_bar_item_set_text_string (PathBarItem* self,
                               const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, path_bar_item_get_text_string (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_text_string);
		self->priv->_text_string = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, path_bar_item_properties[PATH_BAR_ITEM_TEXT_STRING_PROPERTY]);
	}
}


static gboolean
_path_bar_item___lambda19_ (PathBarItem* self)
{
	gboolean result = FALSE;
	PathBarItemCursorType _tmp0_;
	self->priv->hover = TRUE;
	_tmp0_ = self->priv->cursor_type;
	path_bar_item_set_new_cursor_type (self, _tmp0_);
}


static gboolean
__path_bar_item___lambda19__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                           GdkEventCrossing* event,
                                                           gpointer self)
{
	gboolean result;
	result = _path_bar_item___lambda19_ ((PathBarItem*) self);
	return result;
}


static gboolean
_path_bar_item___lambda20_ (PathBarItem* self)
{
	gboolean result = FALSE;
	self->priv->hover = FALSE;
	path_bar_item_set_new_cursor_type (self, PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT);
}


static gboolean
__path_bar_item___lambda20__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                           GdkEventCrossing* event,
                                                           gpointer self)
{
	gboolean result;
	result = _path_bar_item___lambda20_ ((PathBarItem*) self);
	return result;
}


static GObject *
path_bar_item_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PathBarItem * self;
	parent_class = G_OBJECT_CLASS (path_bar_item_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PATH_BAR_ITEM, PathBarItem);
	g_signal_connect_object ((GtkWidget*) self, "enter-notify-event", (GCallback) __path_bar_item___lambda19__gtk_widget_enter_notify_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "leave-notify-event", (GCallback) __path_bar_item___lambda20__gtk_widget_leave_notify_event, self, 0);
	return obj;
}


static void
path_bar_item_class_init (PathBarItemClass * klass)
{
	gint PathBarItem_private_offset;
	path_bar_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PathBarItemPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_path_bar_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_path_bar_item_set_property;
	G_OBJECT_CLASS (klass)->constructor = path_bar_item_constructor;
	G_OBJECT_CLASS (klass)->finalize = path_bar_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY, path_bar_item_properties[PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY] = g_param_spec_string ("alternative-action", "alternative-action", "alternative-action", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY, path_bar_item_properties[PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY] = g_param_spec_string ("default-action", "default-action", "default-action", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PATH_BAR_ITEM_TEXT_STRING_PROPERTY, path_bar_item_properties[PATH_BAR_ITEM_TEXT_STRING_PROPERTY] = g_param_spec_string ("text-string", "text-string", "text-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	PathBarItem_private_offset = g_type_class_get_instance_private_offset (klass);
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/pathbar-item.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_label", FALSE, PathBarItem_private_offset + G_STRUCT_OFFSET (PathBarItemPrivate, text_label));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "update_cursor", G_CALLBACK(_path_bar_item_update_cursor_gtk_button_clicked));
}


static void
path_bar_item_instance_init (PathBarItem * self)
{
	self->priv = PATH_BAR_ITEM_GET_PRIVATE (self);
	self->priv->cursor_type = PATH_BAR_ITEM_CURSOR_TYPE_POINTER;
	self->priv->hover = FALSE;
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void
path_bar_item_finalize (GObject * obj)
{
	PathBarItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PATH_BAR_ITEM, PathBarItem);
	_g_free0 (self->priv->_alternative_action);
	_g_free0 (self->priv->_default_action);
	_g_free0 (self->priv->_text_string);
	_g_object_unref0 (self->priv->text_label);
	G_OBJECT_CLASS (path_bar_item_parent_class)->finalize (obj);
}


GType
path_bar_item_get_type (void)
{
	static volatile gsize path_bar_item_type_id__volatile = 0;
	if (g_once_init_enter (&path_bar_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PathBarItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) path_bar_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PathBarItem), 0, (GInstanceInitFunc) path_bar_item_instance_init, NULL };
		GType path_bar_item_type_id;
		path_bar_item_type_id = g_type_register_static (gtk_button_get_type (), "PathBarItem", &g_define_type_info, 0);
		g_once_init_leave (&path_bar_item_type_id__volatile, path_bar_item_type_id);
	}
	return path_bar_item_type_id__volatile;
}


static void
_vala_path_bar_item_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	PathBarItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PATH_BAR_ITEM, PathBarItem);
	switch (property_id) {
		case PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY:
		g_value_set_string (value, path_bar_item_get_alternative_action (self));
		break;
		case PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY:
		g_value_set_string (value, path_bar_item_get_default_action (self));
		break;
		case PATH_BAR_ITEM_TEXT_STRING_PROPERTY:
		g_value_set_string (value, path_bar_item_get_text_string (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_path_bar_item_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	PathBarItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PATH_BAR_ITEM, PathBarItem);
	switch (property_id) {
		case PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY:
		path_bar_item_set_alternative_action (self, g_value_get_string (value));
		break;
		case PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY:
		path_bar_item_set_default_action (self, g_value_get_string (value));
		break;
		case PATH_BAR_ITEM_TEXT_STRING_PROPERTY:
		path_bar_item_set_text_string (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



